SystemOrganization addCategory: #'Essential-SUnit'!
SystemOrganization addCategory: #'Essential-SLint'!

TestCase subclass: #ESLintTestCase
	instanceVariableNames: 'environment context title failed expected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Essential-SLint'!

!ESLintTestCase commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #implementedNotSent>!

ESLintTestCase subclass: #ESLintSelfTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Essential-SLint'!

!ESLintSelfTest methodsFor: 'accessing' stamp: 'lr 10/28/2005 00:18'!
environment
	^ super environment forPackage: (PackageInfo named: 'Essential').! !

!ESLintSelfTest methodsFor: 'examples' stamp: 'lr 12/21/2005 14:08'!
shouldFail1
	"<lint: #expect rule: #implementedNotSent>"
	"<lint: #expect rule: #shouldFail>"! !

!ESLintSelfTest methodsFor: 'examples' stamp: 'lr 12/21/2005 13:59'!
shouldFail2
	"<lint: #expect rule: #implementedNotSent>"
	"<lint: #ignore rule: #shouldntFail>"

	^ #shouldFail! !

!ESLintSelfTest methodsFor: 'examples' stamp: 'lr 12/21/2005 13:59'!
shouldntFail1
	"<lint: #expect rule: #implementedNotSent>"
	"<lint: #expect rule: #shouldntFail>"

	^ #shouldntFail! !

!ESLintSelfTest methodsFor: 'examples' stamp: 'lr 12/21/2005 14:00'!
shouldntFail2
	"<lint: #expect rule: #implementedNotSent>"
	"<lint: #ignore rule: #shouldntFail>"

	^ #shouldntFail! !

!ESLintSelfTest methodsFor: 'testing-testing' stamp: 'lr 12/21/2005 14:15'!
testShouldFail
	self
		run: #shouldFail
		rule: (ParseTreeLintRule 
			createParseTreeRule: #( '^ #shouldFail' )
			name: 'Should fail').! !

!ESLintSelfTest methodsFor: 'testing-testing' stamp: 'lr 12/21/2005 14:15'!
testShouldntFail
	self
		run: #shouldntFail
		rule: (ParseTreeLintRule 
			createParseTreeRule: #( '^ #shouldntFail' )
			name: 'Shouldn''t fail').! !

!ESLintTestCase class methodsFor: 'private' stamp: 'lr 10/26/2005 21:15'!
buildAll
	BasicLintRule withAllSubclassesDo: [ :each | self buildForClass: each ].! !

!ESLintTestCase class methodsFor: 'private' stamp: 'lr 10/11/2005 22:18'!
buildForClass: aClass
	aClass protocols do: [ :each | self buildForClass: aClass protocol: each ].! !

!ESLintTestCase class methodsFor: 'private' stamp: 'lr 10/11/2005 22:20'!
buildForClass: aClass protocol: aProtocol 
	(aClass class organization listAtCategoryNamed: aProtocol)
		do: [ :each | self buildForClass: aClass protocol: aProtocol method: each ].! !

!ESLintTestCase class methodsFor: 'private' stamp: 'lr 12/21/2005 10:34'!
buildForClass: aClass protocol: aProtocol method: aSelector
	"<lint: #ignore rule: #longMethods>"
	| selector |
	(aClass includesSelector: aSelector)
		ifTrue: [ ^ self ].
	selector := String streamContents: [ :stream |
		stream nextPut: aSelector first asUppercase.
		stream nextPutAll: aSelector allButFirst ].
	self
		compile: (String streamContents: [ :stream |
			stream nextPutAll: 'test'; nextPutAll: selector; cr.
			stream tab; nextPutAll: 'self'; cr.
			stream tab; tab; nextPutAll: 'run: #'; nextPutAll: aSelector; cr.
			stream tab; tab; nextPutAll: 'rule: '; print: aClass; space; nextPutAll: aSelector; nextPut: $. ])
		classified: (String streamContents: [ :stream |
			stream nextPutAll: 'testing-'.
			aProtocol readStream in: [ :input |
				[ input atEnd ] whileFalse: [
					stream nextPutAll: (input upTo: Character space).
					input atEnd ifFalse: [ stream nextPut: $- ] ] ] ]).! !

!ESLintTestCase class methodsFor: 'testing' stamp: 'lr 10/26/2005 17:27'!
isAbstract
	^ super isAbstract or: [ self sunitName = #ESLintTestCase ].! !

!ESLintTestCase class methodsFor: 'accessing' stamp: 'lr 10/26/2005 17:25'!
resources
	^ Array with: ESLintTestResource.! !

!ESLintTestCase methodsFor: 'running' stamp: 'lr 12/30/2005 23:38'!
debug
	expected isEmpty
		ifFalse: [ expected label: 'Expected Failure: ' , title; openEditor ].
	failed isEmpty
		ifFalse: [ failed label: title; openEditor ].! !

!ESLintTestCase methodsFor: 'accessing' stamp: 'lr 10/28/2005 00:17'!
environment
	"Answer the environment to be used with this test-case, defaults to the whole image."
	
	^ BrowserEnvironment new.! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/13/2005 09:25'!
removeAll
	environment := SelectorEnvironment new.! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/13/2005 09:45'!
removeClassesMatching: aString
	environment classes do: [ :each |
		(aString match: each name)
			ifTrue: [ self removeClass: each ] ].! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/13/2005 09:24'!
removeClasses: aCollection
	aCollection do: [ :each | self removeClass: each ].! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/7/2005 15:16'!
removeClass: aClass
	environment removeClass: aClass; removeClass: aClass class.! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/13/2005 09:45'!
removeSelectorsMatching: aString
	environment classes do: [ :class |
		(environment selectorsForClass: class) do: [ :selector | 
			(aString match: selector)
				ifTrue: [ environment removeClass: class selector: selector ] ] ].! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/13/2005 09:34'!
removeSelectors: aCollection
	aCollection do: [ :each | self removeSelector: each ].! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/13/2005 09:45'!
removeSelector: aSelector
	environment classes do: [ :class |
		environment 
			removeClass: class 
			selector: aSelector ].! !

!ESLintTestCase methodsFor: 'configuration' stamp: 'lr 12/7/2005 15:17'!
removeSubclasses: aClass
	aClass allSubclassesDo: [ :each | self removeClass: each ].! !

!ESLintTestCase methodsFor: 'private' stamp: 'lr 12/30/2005 21:12'!
run: aLintSelector rule: aLintRule
	"Run aLintRule on the current environment, aLintSelector is used to identify the ignored and expected methods."
	
	title := aLintRule name.
	failed := aLintRule result.
	expected := SelectorEnvironment new.
	environment classes asArray
		do: [ :each | self run: aLintSelector rule: aLintRule class: each ]
		displayingProgress: (aLintRule name truncateWithElipsisTo: 25).
	self assert: failed isEmpty; assert: expected isEmpty.! !

!ESLintTestCase methodsFor: 'private' stamp: 'lr 12/30/2005 20:55'!
run: aLintSelector rule: aLintRule class: aClass
	context selectedClass: aClass.
	(context isIgnored: aLintSelector)
		ifTrue: [ ^ self ].
	(context isExpected: aLintSelector)
		ifTrue: [ self error: 'Unable to expect lint-failure on class ' , aClass name , '.' ].
	(environment privateSelectorsForClass: aClass) size < aClass methodDict size
		ifFalse: [ aLintRule checkClass: context ].
	environment
		selectorsForClass: aClass
		do: [ :each | self run: aLintSelector rule: aLintRule class: aClass selector: each ].! !

!ESLintTestCase methodsFor: 'private' stamp: 'lr 12/30/2005 20:55'!
run: aLintSelector rule: aLintRule class: aClass selector: aSelector
	context selector: aSelector.
	(context isIgnored: aLintSelector)
		ifTrue: [ ^ self ].
	(context isExpected: aLintSelector)
		ifFalse: [ aLintRule checkMethod: context ]
		ifTrue: [
			(aLintRule copy resetResult; checkMethod: context; yourself) isEmpty
				ifTrue: [
					expected
						addClass: context selectedClass
						selector: context selector ] ].! !

!ESLintTestCase methodsFor: 'running' stamp: 'lr 12/30/2005 20:52'!
setUp
	| resource |
	super setUp.
	resource := self class resources first current.
	environment := (resource environmentFor: self)
		copy.
	context := resource context.! !

!ESLintTestCase methodsFor: 'running' stamp: 'lr 10/28/2005 00:16'!
tearDown
	super tearDown.
	environment := context := nil.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testAbstractClass
	self
		run: #abstractClass
		rule: BlockLintRule abstractClass.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testAddRemoveDependents
	self
		run: #addRemoveDependents
		rule: BlockLintRule addRemoveDependents.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testAsOrderedCollectionNotNeeded
	self
		run: #asOrderedCollectionNotNeeded
		rule: ParseTreeLintRule asOrderedCollectionNotNeeded.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testAssignmentInBlock
	self
		run: #assignmentInBlock
		rule: ParseTreeLintRule assignmentInBlock.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testAssignmentInIfTrue
	self
		run: #assignmentInIfTrue
		rule: ParseTreeLintRule assignmentInIfTrue.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testAtIfAbsent
	self
		run: #atIfAbsent
		rule: ParseTreeLintRule atIfAbsent.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/21/2005 12:16'!
testBadMessage
	self
		run: #badMessage
		rule: (BlockLintRule new
			name: 'Sends "questionable" message';
			methodBlock: [ :lint :result |
				BlockLintRule badSelectors do: [ :selector |
					(lint compiledMethod messages includes: selector) ifTrue: [ 
						result 
							addSearchString: selector; 
							addClass: lint selectedClass selector: lint selector ] ] ];
			yourself).! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testBooleanPrecedence
	self
		run: #booleanPrecedence
		rule: ParseTreeLintRule booleanPrecedence.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testClassInstVarNotInitialized
	self
		run: #classInstVarNotInitialized
		rule: BlockLintRule classInstVarNotInitialized.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testClassNameInSelector
	self
		run: #classNameInSelector
		rule: BlockLintRule classNameInSelector.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/21/2005 14:13'!
testClassNotReferenced
	self removeSubclasses: TestCase.
	self
		run: #classNotReferenced
		rule: BlockLintRule classNotReferenced.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testCollectionCopyEmpty
	self
		run: #collectionCopyEmpty
		rule: BlockLintRule collectionCopyEmpty.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testCollectionMessagesToExternalObject
	self
		run: #collectionMessagesToExternalObject
		rule: ParseTreeLintRule collectionMessagesToExternalObject.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testCollectionProtocol
	self
		run: #collectionProtocol
		rule: ParseTreeLintRule collectionProtocol.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testCollectSelectNotUsed
	self
		run: #collectSelectNotUsed
		rule: ParseTreeLintRule collectSelectNotUsed.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testConsistencyCheck
	self
		run: #consistencyCheck
		rule: ParseTreeLintRule consistencyCheck.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testContains
	self
		run: #contains
		rule: ParseTreeLintRule contains.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testDefinesEqualNotHash
	self
		run: #definesEqualNotHash
		rule: BlockLintRule definesEqualNotHash.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testDetectContains
	self
		run: #detectContains
		rule: ParseTreeLintRule detectContains.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testEndTrueFalse
	self
		run: #endTrueFalse
		rule: ParseTreeLintRule endTrueFalse.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testEqualNotUsed
	self
		run: #equalNotUsed
		rule: ParseTreeLintRule equalNotUsed.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testEqualsTrue
	self
		run: #equalsTrue
		rule: ParseTreeLintRule equalsTrue.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/30/2005 21:22'!
testEquivalentSuperclassMethods
	| superclass this other |
	self
		run: #equivalentSuperclassMethods
		rule: (BlockLintRule new
			name: 'Methods equivalently defined in superclass';
			methodBlock: [ :lint :result |
				(lint selectedClass superclass notNil
					and: [ (superclass := lint selectedClass superclass 
						whichClassIncludesSelector: lint selector) notNil
					and: [ (this := lint parseTree) notNil
					and: [ (other := superclass parseTreeFor: lint selector) notNil
					and: [ this equalTo: other exceptForVariables: #() ] ] ] ])
						ifTrue: [ result addClass: lint selectedClass selector: lint selector ] ];
			yourself).! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testExtraBlock
	self
		run: #extraBlock
		rule: ParseTreeLintRule extraBlock.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testFileBlocks
	self
		run: #fileBlocks
		rule: ParseTreeLintRule fileBlocks.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testFullBlocks
	self
		run: #fullBlocks
		rule: BlockLintRule fullBlocks.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testGuardingClause
	self
		run: #guardingClause
		rule: ParseTreeLintRule guardingClause.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testIfTrueBlocks
	self
		run: #ifTrueBlocks
		rule: ParseTreeLintRule ifTrueBlocks.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testIfTrueReturns
	self
		run: #ifTrueReturns
		rule: ParseTreeLintRule ifTrueReturns.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/21/2005 14:14'!
testImplementedNotSent
	self removeSelectorsMatching: 'test*'.
	self
		run: #implementedNotSent
		rule: BlockLintRule implementedNotSent.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testInstVarInSubclasses
	self
		run: #instVarInSubclasses
		rule: BlockLintRule instVarInSubclasses.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testJustSendsSuper
	self
		run: #justSendsSuper
		rule: BlockLintRule justSendsSuper.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testLiteralArrayCharacters
	self
		run: #literalArrayCharacters
		rule: ParseTreeLintRule literalArrayCharacters.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testLiteralArrayContainsComma
	self
		run: #literalArrayContainsComma
		rule: BlockLintRule literalArrayContainsComma.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testLongMethods
	self
		run: #longMethods
		rule: BlockLintRule longMethods.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testMinMax
	self
		run: #minMax
		rule: ParseTreeLintRule minMax.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testMissingSubclassResponsibility
	self
		run: #missingSubclassResponsibility
		rule: BlockLintRule missingSubclassResponsibility.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testMissingYourself
	self
		run: #missingYourself
		rule: ParseTreeLintRule missingYourself.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testModifiesCollection
	self
		run: #modifiesCollection
		rule: ParseTreeLintRule modifiesCollection.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testOnlyReadOrWritten
	self
		run: #onlyReadOrWritten
		rule: BlockLintRule onlyReadOrWritten.! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testOverridesSpecialMessage
	self
		run: #overridesSpecialMessage
		rule: BlockLintRule overridesSpecialMessage.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testPrecedence
	self
		run: #precedence
		rule: ParseTreeLintRule precedence.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/21/2005 12:16'!
testRefersToClass
	| className classAssoc |
	self
		run: #refersToClass
		rule: (BlockLintRule new
			name: 'Refers to class name instead of "self class"';
			methodBlock: [ :lint :result |
				className := (lint selectedClass isMeta
					ifTrue: [ lint selectedClass soleInstance]
					ifFalse: [ lint selectedClass]) name.
				classAssoc := Smalltalk associationAt: className.
				((lint compiledMethod literals includes: classAssoc) 
					and: [ lint compiledMethod sendsToSuper not ]) ifTrue: [ 
					result 
						addSearchString: className; 
						addClass: lint selectedClass selector: lint selector ] ];
			yourself).! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testReturnInEnsure
	self
		run: #returnInEnsure
		rule: ParseTreeLintRule returnInEnsure.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testReturnsBooleanAndOther
	self
		run: #returnsBooleanAndOther
		rule: BlockLintRule returnsBooleanAndOther.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testReturnsIfTrue
	self
		run: #returnsIfTrue
		rule: ParseTreeLintRule returnsIfTrue.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testSearchingLiteral
	self
		run: #searchingLiteral
		rule: ParseTreeLintRule searchingLiteral.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testSendsDifferentSuper
	self
		run: #sendsDifferentSuper
		rule: BlockLintRule sendsDifferentSuper.! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testSentNotImplemented
	self
		run: #sentNotImplemented
		rule: BlockLintRule sentNotImplemented.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testSizeCheck
	self
		run: #sizeCheck
		rule: ParseTreeLintRule sizeCheck.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testStringConcatenation
	self
		run: #stringConcatenation
		rule: ParseTreeLintRule stringConcatenation.! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testSubclassResponsibilityNotDefined
	self
		run: #subclassResponsibilityNotDefined
		rule: BlockLintRule subclassResponsibilityNotDefined.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testSuperSends
	self
		run: #superSends
		rule: BlockLintRule superSends.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testTempsReadBeforeWritten
	self
		run: #tempsReadBeforeWritten
		rule: BlockLintRule tempsReadBeforeWritten.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testTempVarOverridesInstVar
	self
		run: #tempVarOverridesInstVar
		rule: BlockLintRule tempVarOverridesInstVar.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testThreeElementPoint
	self
		run: #threeElementPoint
		rule: ParseTreeLintRule threeElementPoint.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testToDo
	self
		run: #toDo
		rule: ParseTreeLintRule toDo.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testToDoCollect
	self
		run: #toDoCollect
		rule: ParseTreeLintRule toDoCollect.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testToDoWithIncrement
	self
		run: #toDoWithIncrement
		rule: ParseTreeLintRule toDoWithIncrement.! !

!ESLintTestCase methodsFor: 'testing-userdefined' stamp: 'lr 12/21/2005 14:36'!
testUnclassifiedMethods
	self
		run: #unclassifiedMethods
		rule: (BlockLintRule new
			name: 'Unclassified methods';
			methodBlock: [ :lint :result |
				(lint selectedClass organization categoryOfElement: lint selector) = Categorizer default
					ifTrue: [ result addClass: lint selectedClass selector: lint selector ] ];
			yourself).! !

!ESLintTestCase methodsFor: 'testing-userdefined' stamp: 'lr 12/21/2005 15:09'!
testUnconditionalRecursion
	self
		run: #unconditionalRecursion
		rule: (ParseTreeLintRule
			createParseTreeRule: #(
				'`@message: `@args
					| `@temps |
					self `@message: `@args'
				'`@message: `@args
					| `@temps |
					self `@message: `@args.
					`@.statements'
				'`@message: `@args1
					| `@temps |
					`{ :node :context | node containsReturn not }.
					self `@message: `@args2'
				'`@message: `@args1
					| `@temps |
					`{ :node :context | node containsReturn not }.
					self `@message: `@args2.
					`@.statements' )
			method: true
			name: 'Unconditional recursion').! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testUndeclaredReference
	self
		run: #undeclaredReference
		rule: BlockLintRule undeclaredReference.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testUnnecessaryAssignment
	self
		run: #unnecessaryAssignment
		rule: ParseTreeLintRule unnecessaryAssignment.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testUnoptimizedAndOr
	self
		run: #unoptimizedAndOr
		rule: ParseTreeLintRule unoptimizedAndOr.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testUnoptimizedToDo
	self
		run: #unoptimizedToDo
		rule: ParseTreeLintRule unoptimizedToDo.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testUnreferencedVariables
	self
		run: #unreferencedVariables
		rule: BlockLintRule unreferencedVariables.! !

!ESLintTestCase methodsFor: 'testing-possible-bugs' stamp: 'lr 12/7/2005 13:54'!
testUsesAdd
	self
		run: #usesAdd
		rule: ParseTreeLintRule usesAdd.! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testUsesTrue
	self
		run: #usesTrue
		rule: BlockLintRule usesTrue.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testUtilityMethods
	self
		run: #utilityMethods
		rule: BlockLintRule utilityMethods.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testVariableAssignedLiteral
	self
		run: #variableAssignedLiteral
		rule: BlockLintRule variableAssignedLiteral.! !

!ESLintTestCase methodsFor: 'testing-bugs' stamp: 'lr 12/7/2005 13:54'!
testVariableNotDefined
	self
		run: #variableNotDefined
		rule: BlockLintRule variableNotDefined.! !

!ESLintTestCase methodsFor: 'testing-unnecessary-code' stamp: 'lr 12/7/2005 13:54'!
testVariableReferencedOnce
	self
		run: #variableReferencedOnce
		rule: BlockLintRule variableReferencedOnce.! !

!ESLintTestCase methodsFor: 'testing-intention-revealing' stamp: 'lr 12/7/2005 13:54'!
testWhileTrue
	self
		run: #whileTrue
		rule: ParseTreeLintRule whileTrue.! !

!ESLintTestCase methodsFor: 'testing-miscellaneous' stamp: 'lr 12/7/2005 13:54'!
testYourselfNotUsed
	self
		run: #yourselfNotUsed
		rule: ParseTreeLintRule yourselfNotUsed.! !

SmalllintContext subclass: #ESLintContext
	instanceVariableNames: 'sourceCode parseTrees ignored expected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Essential-SLint'!

!ESLintContext methodsFor: 'private' stamp: 'lr 10/28/2005 13:27'!
buildParseTree
	"Parsing in Squeak is slow, therefor it is a good idea to cache it. This gives a average speedup of 30%."

	"<lint: #expect rule: #overridesSuper rational: 'to use the cached source-code we cannot directly use the super method'>"

	^ (parseTrees at: class ifAbsentPut: [ IdentityDictionary new ])
		at: selector ifAbsentPut: [ self buildParseTreeActually ].! !

!ESLintContext methodsFor: 'private' stamp: 'lr 10/28/2005 12:51'!
buildParseTreeActually
	| tree |
	tree := RBParser 
		parseMethod: self sourceCode 
		onError: [ :string :pos | ^ RBParser parseMethod: 'method' ].
	^ tree.! !

!ESLintContext methodsFor: 'private' stamp: 'lr 12/7/2005 13:50'!
fetchSourceCode
	^ selector isNil
		ifTrue: [ class organization comment ]
		ifFalse: [ class sourceCodeAt: selector ].! !

!ESLintContext methodsFor: 'testing' stamp: 'lr 10/31/2005 17:48'!
hasSourceCode
	(sourceCode at: class ifAbsent: [ ^ false ])
		at: selector ifAbsent: [ ^ false ].
	^ true.! !

!ESLintContext methodsFor: 'initialize' stamp: 'lr 12/21/2005 09:55'!
initialize
	super initialize.
	sourceCode := IdentityDictionary new.
	parseTrees := IdentityDictionary new.
	ignored := IdentityDictionary new.
	expected := IdentityDictionary new.! !

!ESLintContext methodsFor: 'testing' stamp: 'lr 12/21/2005 09:55'!
isExpected: aSelector
	^ ((expected at: class ifAbsent: [ ^ false ])
		at: selector ifAbsent: [ ^ false ])
			includes: aSelector.! !

!ESLintContext methodsFor: 'testing' stamp: 'lr 10/28/2005 01:23'!
isIgnored: aSelector
	^ ((ignored at: class ifAbsent: [ ^ false ])
		at: selector ifAbsent: [ ^ false ])
			includes: aSelector.! !

!ESLintContext methodsFor: 'pragmas' stamp: 'lr 12/21/2005 12:16'!
lint: aWhatSelector rule: aRuleSelector
	"<lint: #expect rule: #collectionMessagesToExternalObject rational: 'lint is wrong here'>"
	
	(((aWhatSelector = #ignore
		ifTrue: [ ignored ]
		ifFalse: [
			aWhatSelector = #expect
				ifTrue: [ expected ]
				ifFalse: [ ^ self warn: 'invalid selector' ] ])
		at: class ifAbsentPut: [ IdentityDictionary new ])
			at: selector ifAbsentPut: [ IdentitySet new ])
				add: aRuleSelector.! !

!ESLintContext methodsFor: 'pragmas' stamp: 'lr 11/14/2005 19:33'!
lint: aWhatSelector rule: aRuleSelector rational: aString
	"<lint: #expect rule: #implementedNotSent rational: 'this method is used from pragmas only'>"

	self lint: aWhatSelector rule: aRuleSelector.! !

!ESLintContext methodsFor: 'private' stamp: 'lr 12/7/2005 15:26'!
parsePragma
	| stream |
	stream := self sourceCode readStream.
	[ stream atEnd ] whileFalse: [
		stream upToAll: '<' , 'lint:'.
		stream atEnd ifFalse: [
			[ self class compilerClass new
				evaluate: 'self lint:' , (stream upTo: $>) 
				in: thisContext to: self notifying: nil
				ifFail: [ self warn: 'invalid pragma' ] 
				logged: false ]
					on: Error 
					do: [ :err | self warn: 'syntax error in pragma' ] ] ].
! !

!ESLintContext methodsFor: 'accessing' stamp: 'lr 10/28/2005 12:53'!
selectedClass: anObject
	super selectedClass: anObject.
	self hasSourceCode
		ifFalse: [ self parsePragma ].! !

!ESLintContext methodsFor: 'accessing' stamp: 'lr 10/28/2005 12:57'!
selector: anObject
	super selector: anObject.
	self hasSourceCode
		ifFalse: [ self parsePragma ].! !

!ESLintContext methodsFor: 'accessing' stamp: 'lr 12/7/2005 13:50'!
sourceCode
	"Accessing source code in Squeak is slow, therefor it is a good idea to cache it. This gives a average speedup of 20%."

	^ (sourceCode at: class ifAbsentPut: [ IdentityDictionary new ])
		at: selector 
		ifAbsentPut: [
			selector isNil
				ifTrue: [ class comment ]
				ifFalse: [ self fetchSourceCode ] ].! !

!ESLintContext methodsFor: 'private' stamp: 'lr 10/28/2005 01:13'!
warn: aString
	Transcript nextPutAll: self selectedClass name.
	self selector isNil 
		ifFalse: [ Transcript nextPutAll: '>>'; nextPutAll: self selector ].
	Transcript space; nextPutAll: aString; cr; endEntry.! !

!MultiEnvironment methodsFor: '*essential' stamp: 'lr 12/13/2005 15:00'!
openEditor
	self explore.! !

Object subclass: #ESTestRunner
	instanceVariableNames: 'categories categoriesSelected classes classesSelected failedList failedSelected errorList errorSelected lastUpdate result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Essential-SUnit'!

!ESTestRunner commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!

!ESTestRunner class methodsFor: 'initialization' stamp: 'lr 12/7/2005 13:56'!
initialize
	self registerInWorldMenu; registerInToolsFlap.! !

!ESTestRunner class methodsFor: 'instance-creation' stamp: 'lr 10/8/2005 18:35'!
open
	^ ToolBuilder open: self new.! !

!ESTestRunner class methodsFor: 'initialization' stamp: 'lr 11/14/2005 19:24'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( ESTestRunner open 'Essential Runner' 'A production scale test-runner.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!ESTestRunner class methodsFor: 'initialization' stamp: 'lr 11/14/2005 19:20'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'Essential Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!ESTestRunner methodsFor: 'accessing' stamp: 'lr 10/31/2005 15:31'!
baseClass
	^ TestCase! !

!ESTestRunner methodsFor: 'processing' stamp: 'lr 10/31/2005 17:43'!
basicRunSuite: aTestSuite do: aBlock
	self basicSetUpSuite: aTestSuite.
	[ aTestSuite name isEmptyOrNil
		ifTrue: [ aTestSuite tests do: aBlock ]
		ifFalse: [ aTestSuite tests do: aBlock displayingProgress: aTestSuite name ] ]
			ensure: [ self basicTearDownSuite: aTestSuite ].
	! !

!ESTestRunner methodsFor: 'processing' stamp: 'lr 10/27/2005 10:04'!
basicSetUpSuite: aTestSuite
	aTestSuite resources do: [ :each |
		each isAvailable
			ifFalse: [ each signalInitializationError ] ].! !

!ESTestRunner methodsFor: 'processing' stamp: 'lr 10/27/2005 10:04'!
basicTearDownSuite: aTestSuite
	aTestSuite resources do: [ :each | each reset ].! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:36'!
browseReferencedClasses
	| references |
	references := classesSelected gather: [ :class |
		class methodDict values , class class methodDict values gather: [ :method |
			method literals
				select: [ :each | each isVariableBinding and: [ each value isBehavior ] ]
				thenCollect: [ :each | each value ] ] ].
	(self browserEnvironment new forClasses: references asSet)
		label: 'Referenced Classes';
		openEditor.! !

!ESTestRunner methodsFor: 'private' stamp: 'lr 11/21/2005 13:36'!
browserEnvironment
	^ Smalltalk classNamed: #BrowserEnvironment.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/10/2005 21:26'!
browseSentMessages
	| references |
	references := classesSelected gather: [ :class |
		class methodDict values , class class methodDict values gather: [ :method |
			(method literals copyWithoutAll: class allSelectors , class class allSelectors)
				select: [ :each | each isSymbol ] ] ].
	self systemNavigation
		browseAllImplementorsOfList: references asSet
		title: 'Sent Messages'.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:36'!
browseTestClasses
	(self browserEnvironment new forClasses: classesSelected asSet)
		label: 'Test Classes';
		openEditor.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 11/21/2005 13:22'!
buildButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self buttons collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 10/31/2005 15:12'!
buildCategoriesWith: aBuilder
	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #categoryList;
		menu: #categoryMenu:;
		getIndex: #categorySelected;
		setIndex: #categorySelected:;
		getSelectionList: #categoryAt:;
		setSelectionList: #categoryAt:put:;
		yourself.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 10/17/2005 09:13'!
buildClassesWith: aBuilder
	^ aBuilder pluggableMultiSelectionListSpec new
		model: self;
		list: #classList;
		menu: #classMenu:;
		getIndex: #classSelected;
		setIndex: #classSelected:;
		getSelectionList: #classAt:;
		setSelectionList: #classAt:put:;
		yourself.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 10/6/2005 19:39'!
buildErrorListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Error List';
		list: #errorList; 
		getIndex: #errorSelected; 
		setIndex: #errorSelected:;
		yourself.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 10/6/2005 19:47'!
buildFailureListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Failure List';
		list: #failedList; 
		getIndex: #failedSelected; 
		setIndex: #failedSelected:;
		yourself.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 10/8/2005 23:06'!
buildStatusWith: aBuilder
	^ aBuilder pluggableInputFieldSpec new
		model: self;
		color: #statusColor;
		getText: #statusText;
		yourself.! !

!ESTestRunner methodsFor: 'building' stamp: 'lr 10/31/2005 15:12'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.92 );
				yourself);
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.92 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.92);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.92 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		yourself.
	^ aBuilder build: window.! !

!ESTestRunner methodsFor: 'accessing-ui' stamp: 'lr 11/21/2005 13:18'!
buttons
	^ #(( 'Run All' #runAll #hasRunnable )
		( 'Run Profiled' #runProfiled #hasRunnable )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors )).! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:09'!
categoryAt: anIndex
	^ categoriesSelected includes: (categories at: anIndex ifAbsent: [ ^ false ]).! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:51'!
categoryAt: anInteger put: aBoolean
	categoriesSelected := categoriesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (categories at: anInteger ifAbsent: [ ^ self ]).
	self changed: #categorySelected; updateClasses.! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:10'!
categoryList
	^ categories! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:25'!
categoryMenu: aMenu
	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself.! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:11'!
categorySelected
	^ 0! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:12'!
categorySelected: anInteger
	self changed: #categorySelected.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 10/8/2005 19:58'!
classAt: anInteger
	^ classesSelected includes: (classes at: anInteger ifAbsent: [ ^ false ]).! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:19'!
classAt: anInteger put: aBoolean
	classesSelected := classesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (classes at: anInteger ifAbsent: [ ^ self ]).
	self changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 10/10/2005 11:24'!
classList
	| offset ident |
	classes isEmpty ifTrue: [ ^ classes ].
	offset := classes first allSuperclasses size.
	^ classes collect: [ :each |
		ident := String 
			new: 2 * (0 max: each allSuperclasses size - offset) 
			withAll: $ .
		each isAbstract
			ifFalse: [ ident , each name ]
			ifTrue: [ 
				ident asText , each name asText 
					addAttribute: TextEmphasis italic;
					yourself ] ].! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:37'!
classMenu: aMenu
	| menu |
	menu := aMenu
		title: 'Classes';
		yourself.
	self browserEnvironment notNil ifTrue: [ 
		menu
			add: 'Browse classes' action: #browseTestClasses;
			add: 'Browse referenced classes' action: #browseReferencedClasses ].
	^ menu
		add: 'Browse sent messages' action: #browseSentMessages;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses;
		yourself.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 10/8/2005 22:30'!
classSelected
	^ 0! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 10/8/2005 22:30'!
classSelected: anInteger
	self changed: #classSelected.! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/31/2005 17:01'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | each debug ].! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/31/2005 17:42'!
debug: aTestCase
	self debugSuite: (TestSuite new
		addTest: aTestCase; 
		yourself).! !

!ESTestRunner methodsFor: 'private' stamp: 'lr 10/28/2005 13:28'!
defaultBackgroundColor
	"<lint: #expect rule: #overridesSuper rational: 'we want a different color than the parent'>"

	^ Color orange.! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:37'!
errorList
	^ errorList collect: [ :each | each printString ].! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 19:46'!
errorSelected
	^ errorList indexOf: errorSelected.! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/27/2005 10:37'!
errorSelected: anInteger
	errorSelected := errorList at: anInteger ifAbsent: nil.
	self changed: #errorSelected.
	errorSelected ifNotNil: [ self debug: errorSelected ].! !

!ESTestRunner methodsFor: 'accessing-ui' stamp: 'lr 10/8/2005 18:39'!
extent
	^ 640 @ 480! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:37'!
failedList
	^ failedList collect: [ :each | each printString ].! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 19:47'!
failedSelected
	^ failedList indexOf: failedSelected.! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 20:14'!
failedSelected: anInteger
	failedSelected := failedList at: anInteger ifAbsent: nil.
	self changed: #failedSelected.
	failedSelected ifNotNil: [ self debug: failedSelected ].! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:27'!
filterCategories
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select categories:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	categoriesSelected := (categories 
		select: [ :each | pattern match: each ]) asSet.
	self changed: #categorySelected; updateClasses.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:20'!
filterClasses
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select tests:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	classesSelected := (classes select: [ :each | 
		pattern match: each name ]) asSet.
	self changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'utilities' stamp: 'lr 10/31/2005 15:41'!
findCategories
	| visible |
	visible := Set new.
	self baseClass withAllSubclassesDo: [ :each | 
		visible add: each category ].
	^ Array streamContents: [ :stream |
		Smalltalk organization categories do: [ :each |
			(visible includes: each)
				ifTrue: [ stream nextPut: each ] ] ].! !

!ESTestRunner methodsFor: 'utilities' stamp: 'lr 10/31/2005 16:05'!
findClassesForCategories: aCollection
	| items |
	aCollection isEmpty 
		ifTrue: [ ^ self baseClass withAllSubclasses ].
	items := aCollection gather: [ :category |
		((Smalltalk organization listAtCategoryNamed: category)
			collect: [ :each | Smalltalk at: each ])
			select: [ :each | each includesBehavior: self baseClass ] ].
	^ items asSet.! !

!ESTestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasErrors
	^ result hasErrors.! !

!ESTestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasFailures
	^ result hasFailures.! !

!ESTestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasRunnable
	^ classesSelected notEmpty.! !

!ESTestRunner methodsFor: 'initialization' stamp: 'lr 10/31/2005 16:15'!
initialize
	super initialize.
	failedList := errorList := Array new.
	self updateCategories; updateClasses; reset.! !

!ESTestRunner methodsFor: 'accessing-ui' stamp: 'lr 10/27/2005 10:43'!
label
	^ 'Essential Test Runner' ! !

!ESTestRunner methodsFor: 'private' stamp: 'lr 10/27/2005 10:32'!
label: aString forSuite: aTestSuite
	^ String streamContents: [ :stream |
		stream nextPutAll: 'Running '; print: aTestSuite tests size; space; nextPutAll: aString.
		aTestSuite tests size > 1 ifTrue: [ stream nextPut: $s ] ]. ! !

!ESTestRunner methodsFor: 'private' stamp: 'lr 12/21/2005 10:39'!
perform: selector orSendTo: otherTarget
	"<lint: #expect rule: #badMessage rational: 'this is a common morphic pattern'>"
	
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ super perform: selector orSendTo: otherTarget ].! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/8/2005 22:52'!
reset
	self result: TestResult new; updateResults.! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 15:47'!
result
	^ result! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:47'!
result: aResult
	result := aResult! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/20/2005 16:28'!
runAll
	self reset; runSuite: self suiteAll.! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/8/2005 23:02'!
runErrors
	self result instVarNamed: 'errors' put: OrderedCollection new.
	self runSuite: self suiteErrors.! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/27/2005 10:42'!
runFailures
	self result instVarNamed: 'failures' put: Set new.
	self runSuite: self suiteFailures.! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/31/2005 17:13'!
runProfiled
	MessageTally spyOn: [ self runAll ].! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 10/31/2005 17:00'!
runSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self runTest: each ].
	self updateResults.! !

!ESTestRunner methodsFor: 'actions' stamp: 'lr 11/3/2005 09:15'!
runTest: aTestCase
	aTestCase run: result.
	self updateStatus: true.! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:27'!
selectAllCategories
	categoriesSelected := categories asSet.
	self changed: #categorySelected; updateClasses.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:20'!
selectAllClasses
	classesSelected := classes asSet.
	self changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:27'!
selectInverseCategories
	categoriesSelected := categories asSet 
		removeAll: categoriesSelected;
		yourself.
	self changed: #categorySelected; updateClasses.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:20'!
selectInverseClasses
	classesSelected := classes asSet 
		removeAll: classesSelected;
		yourself.
	self changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:27'!
selectNoCategories
	categoriesSelected := Set new.
	self changed: #categorySelected; updateClasses.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:20'!
selectNoClasses
	classesSelected := Set new.
	self changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:26'!
selectSubclasses
	| classesForPackages |
	classesForPackages := self findClassesForCategories: categoriesSelected.	
	classesSelected := (classesSelected gather: [ :class |
		class withAllSubclasses select: [ :each |
			classesForPackages includes: each ] ])
		asSet.
	self changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'utilities' stamp: 'lr 10/10/2005 08:43'!
sortClass: aFirstClass before: aSecondClass
	| first second |
	first := aFirstClass withAllSuperclasses reversed.
	second := aSecondClass withAllSuperclasses reversed.
	1 to: (first size min: second size) do: [ :index | 
		(first at: index) == (second at: index)
			ifFalse: [ ^ (first at: index) name <= (second at: index) name ] ].
	^ second includes: aFirstClass.! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 11/1/2005 19:37'!
statusColor
	result hasPassed 
		ifTrue:[ ^ Color green ].
	result hasErrors 
		ifTrue: [ ^ Color red ].
	^ Color yellow.! !

!ESTestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:45'!
statusText
	^ result printString.! !

!ESTestRunner methodsFor: 'accessing' stamp: 'lr 11/3/2005 09:37'!
suiteAll
	^ TestSuite new in: [ :suite |
		classesSelected do: [ :each | 
			each isAbstract 
				ifFalse: [ each addToSuiteFromSelectors: suite ] ].
		suite name: (self label: 'Test' forSuite: suite) ].! !

!ESTestRunner methodsFor: 'accessing' stamp: 'lr 10/27/2005 10:29'!
suiteErrors
	^ TestSuite new in: [ :suite |
		suite 
			addTests: errorList; 
			name: (self label: 'Error' forSuite: suite) ].! !

!ESTestRunner methodsFor: 'accessing' stamp: 'lr 10/27/2005 10:42'!
suiteFailures
	^ TestSuite new in: [ :suite |
		suite 
			addTests: failedList; 
			name: (self label: 'Failure' forSuite: suite) ].! !

!ESTestRunner methodsFor: 'updating' stamp: 'lr 10/31/2005 15:45'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categoriesSelected isNil
		ifTrue: [ Set new ]
		ifFalse: [
			categoriesSelected
				select: [ :each | categories includes: each ] ].
	self changed: #categoryList; changed: #categorySelected.! !

!ESTestRunner methodsFor: 'updating' stamp: 'lr 11/21/2005 13:20'!
updateClasses
	| classesForCategories |
	classesForCategories := self findClassesForCategories: categoriesSelected.
	classes := classesForCategories asArray
		sort: [ :a :b | self sortClass: a before: b ].
	classesSelected := classesSelected isNil
		ifTrue: [ classesForCategories ]
		ifFalse: [ 
			classesSelected
				select: [ :each | classesForCategories includes: each ] ].
	self changed: #classList; changed: #classSelected; changed: #hasRunnable.! !

!ESTestRunner methodsFor: 'updating' stamp: 'lr 12/21/2005 14:17'!
updateResults
	"<lint: #expect rule: #guardingClause>"
	"<lint: #expect rule: #longMethods>"

	self updateStatus: false.
	failedList size = result failures size ifFalse: [
		failedList := result failures asArray
			sort: [ :a :b | a printString <= b printString ].
		failedSelected := nil.
		self 
			changed: #failedList; 
			changed: #failedSelected;
			changed: #hasFailures ].
	errorList size = result errors size ifFalse: [
		errorList := result errors asArray
			sort: [ :a :b | a printString <= b printString ].
		errorSelected := nil.
		self 
			changed: #errorList; 
			changed: #errorSelected;
			changed: #hasErrors ].! !

!ESTestRunner methodsFor: 'updating' stamp: 'lr 11/3/2005 09:28'!
updateStatus: aBoolean
	"Update the status display, at most once a second if aBoolean is true."

	(aBoolean and: [ lastUpdate = Time totalSeconds ])
		ifTrue: [ ^ self ].
	self changed: #statusText; changed: #statusColor.
	lastUpdate := Time totalSeconds.! !

TestResource subclass: #ESLintTestResource
	instanceVariableNames: 'context environments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Essential-SLint'!

!ESLintTestResource methodsFor: 'accessing' stamp: 'lr 10/26/2005 15:40'!
context
	^ context! !

!ESLintTestResource methodsFor: 'accessing' stamp: 'lr 12/24/2005 11:53'!
environmentFor: aTestCase
	^ environments 
		at: aTestCase class 
		ifAbsentPut: [ aTestCase environment asSelectorEnvironment ].! !

!ESLintTestResource methodsFor: 'running' stamp: 'lr 10/28/2005 12:38'!
setUp
	super setUp.
	context := ESLintContext new.
	environments := IdentityDictionary new.! !

!ESLintTestResource methodsFor: 'running' stamp: 'lr 10/26/2005 16:18'!
tearDown
	super tearDown.
	context := environments := nil.! !
ESTestRunner initialize!
